Index: trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 2528)
@@ -5,8 +5,9 @@
    !!                 turbulent closure parameterization
    !!=====================================================================
-   !! History :  8.1  ! 00-03 (W.G. Large, J. Chanut) Original code
-   !!            8.1  ! 02-06 (J.M. Molines) for real case CLIPPER  
-   !!            8.2  ! 03-10 (Chanut J.) re-writting
-   !!            9.0  ! 05-01 (C. Ethe) Free form, F90
+   !! History :  OPA  ! 2000-03 (W.G. Large, J. Chanut) Original code
+   !!            8.1  ! 2002-06 (J.M. Molines) for real case CLIPPER  
+   !!            8.2  ! 2003-10 (Chanut J.) re-writting
+   !!   NEMO     1.0  ! 2005-01 (C. Ethe, G. Madec) Free form, F90 + creation of tra_kpp routine
+   !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
    !!----------------------------------------------------------------------
 #if defined key_zdfkpp   ||   defined key_esopa
@@ -14,7 +15,8 @@
    !!   'key_zdfkpp'                                             KPP scheme
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
    !!   zdf_kpp      : update momentum and tracer Kz from a kpp scheme
    !!   zdf_kpp_init : initialization, namelist read, and parameters control
+   !!   tra_kpp      : compute and add to the T & S trend the non-local flux
+   !!   trc_kpp      : compute and add to the passive tracer trend the non-local flux (lk_top=T)
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers 
@@ -28,11 +30,16 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
-   USE trdmod          ! momentum/tracers trends 
+   USE trdmod_oce      ! ocean trends definition
+   USE trdtra          ! tracers trends
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   zdf_kpp   ! routine called by step.F90
-   PUBLIC   tra_kpp   ! routine called by step.F90
+   PUBLIC   zdf_kpp       ! routine called by step.F90
+   PUBLIC   zdf_kpp_init  ! routine called by opa.F90
+   PUBLIC   tra_kpp       ! routine called by step.F90
+#if defined key_top
+   PUBLIC   trc_kpp       ! routine called by trcstp.F90
+#endif
 
    LOGICAL , PUBLIC, PARAMETER ::   lk_zdfkpp = .TRUE.    !: KPP vertical mixing flag
@@ -53,82 +60,81 @@
 
 #if defined key_zdfddm
-   REAL(wp) ::                 & !!! ** Double diffusion Mixing
-      difssf  = 1.e-03_wp   ,  &  ! maximum salt fingering mixing 
-      Rrho0   = 1.9_wp      ,  &  ! limit for salt  fingering mixing 
-      difsdc  = 1.5e-06_wp       ! maximum diffusive convection mixing
+   !                                        !!! ** Double diffusion Mixing
+   REAL(wp) ::   difssf  = 1.e-03_wp         ! maximum salt fingering mixing 
+   REAL(wp) ::   Rrho0   = 1.9_wp            ! limit for salt  fingering mixing 
+   REAL(wp) ::   difsdc  = 1.5e-06_wp        ! maximum diffusive convection mixing
 #endif
    LOGICAL  ::   ln_kpprimix  = .TRUE.       ! Shear instability mixing 
 
-   REAL(wp) ::                 & !!! ** General constants  **
-      epsln   = 1.0e-20_wp   , &  ! a small positive number    
-      pthird  = 1._wp/3._wp  , &  ! 1/3
-      pfourth = 1._wp/4._wp       ! 1/4
-
-   REAL(wp) ::                 & !!! ** Boundary Layer Turbulence Parameters  **
-      vonk     = 0.4_wp     ,  &  ! von Karman's constant
-      epsilon  = 0.1_wp     ,  &  ! nondimensional extent of the surface layer
-      rconc1   = 5.0_wp     ,  &  ! standard flux profile function parmaeters
-      rconc2   = 16.0_wp    ,  &  !         "        "
-      rconcm   = 8.38_wp    ,  &  ! momentum flux profile fit
-      rconam   = 1.26_wp    ,  &  !         "       "
-      rzetam   = -.20_wp    ,  &  !         "       "       
-      rconcs   = 98.96_wp   ,  &  !  scalar  flux profile fit
-      rconas   = -28.86_wp  ,  &  !         "       "
-      rzetas   = -1.0_wp          !         "       "  
-   REAL(wp) ::                 & !!! ** Boundary Layer Depth Diagnostic  **
-      Ricr     = 0.3_wp     ,  &  ! critical bulk Richardson Number
-      rcekman  = 0.7_wp     ,  &  ! coefficient for ekman depth  
-      rcmonob  = 1.0_wp     ,  &  ! coefficient for Monin-Obukhov depth 
-      rconcv   = 1.7_wp     ,  &  ! ratio of interior buoyancy frequency to buoyancy frequency at entrainment depth
-      hbf      = 1.0_wp     ,  &  ! fraction of bound. layer depth to which absorbed solar 
-      !                           ! rad. and contributes to surf. buo. forcing
-      Vtc                         ! function of rconcv,rconcs,epsilon,vonk,Ricr
-   REAL(wp) ::                 & !!! ** Nonlocal Boundary Layer Mixing **
-      rcstar   = 5.0_wp     ,  &  ! coefficient for convective nonlocal transport
-      rcs      = 1.0e-3_wp  ,  &  ! conversion: mm/s ==> m/s   
-      rcg                         ! non-dimensional coefficient for nonlocal transport
+   !                                        !!! ** General constants  **
+   REAL(wp) ::   epsln   = 1.0e-20_wp        ! a small positive number    
+   REAL(wp) ::   pthird  = 1._wp/3._wp       ! 1/3
+   REAL(wp) ::   pfourth = 1._wp/4._wp       ! 1/4
+
+   !                                        !!! ** Boundary Layer Turbulence Parameters  **
+   REAL(wp) ::   vonk     = 0.4_wp           ! von Karman's constant
+   REAL(wp) ::   epsilon  = 0.1_wp           ! nondimensional extent of the surface layer
+   REAL(wp) ::   rconc1   = 5.0_wp           ! standard flux profile function parmaeters
+   REAL(wp) ::   rconc2   = 16.0_wp          !         "        "
+   REAL(wp) ::   rconcm   = 8.38_wp          ! momentum flux profile fit
+   REAL(wp) ::   rconam   = 1.26_wp          !         "       "
+   REAL(wp) ::   rzetam   = -.20_wp          !         "       "       
+   REAL(wp) ::   rconcs   = 98.96_wp         !  scalar  flux profile fit
+   REAL(wp) ::   rconas   = -28.86_wp        !         "       "
+   REAL(wp) ::   rzetas   = -1.0_wp          !         "       "  
+   
+   !                                        !!! ** Boundary Layer Depth Diagnostic  **
+   REAL(wp) ::   Ricr     = 0.3_wp           ! critical bulk Richardson Number
+   REAL(wp) ::   rcekman  = 0.7_wp           ! coefficient for ekman depth  
+   REAL(wp) ::   rcmonob  = 1.0_wp           ! coefficient for Monin-Obukhov depth 
+   REAL(wp) ::   rconcv   = 1.7_wp           ! ratio of interior buoyancy frequency to its value at entrainment depth
+   REAL(wp) ::   hbf      = 1.0_wp           ! fraction of bound. layer depth to which absorbed solar 
+      !                                      ! rad. and contributes to surf. buo. forcing
+   REAL(wp) ::   Vtc                         ! function of rconcv,rconcs,epsilon,vonk,Ricr
+   
+   !                                        !!! ** Nonlocal Boundary Layer Mixing **
+   REAL(wp) ::   rcstar   = 5.0_wp           ! coefficient for convective nonlocal transport
+   REAL(wp) ::   rcs      = 1.0e-3_wp        ! conversion: mm/s ==> m/s   
+   REAL(wp) ::   rcg                         ! non-dimensional coefficient for nonlocal transport
 
 #if ! defined key_kppcustom
-   REAL(wp), DIMENSION(jpk,jpk) ::   del   ! array for reference mean values of vertical integration 
+   REAL(wp), DIMENSION(jpk,jpk) ::   del     ! array for reference mean values of vertical integration 
 #endif
 
 #if defined key_kpplktb
-   INTEGER, PARAMETER ::       & !!! ** Parameters for lookup table for turbulent velocity scales ** 
-      nilktb   = 892        ,  &  ! number of values for zehat in KPP lookup table
-      njlktb   = 482        ,  &  ! number of values for ustar in KPP lookup table
-      nilktbm1 = nilktb - 1 ,  &  !
-      njlktbm1 = njlktb - 1       !
-
-   REAL(wp), DIMENSION(nilktb,njlktb) ::   wmlktb   ! lookup table for the turbulent vertical velocity scale for momentum
-   REAL(wp), DIMENSION(nilktb,njlktb) ::   wslktb   ! lookup table for the turbulent vertical velocity scale for tracers
-
-   REAL(wp) ::                 &
-      dehatmin = -4.e-7_wp  ,  &  ! minimum limit for zhat in lookup table (m3/s3) 
-      dehatmax = 0._wp      ,  &  ! maximum limit for zhat in lookup table (m3/s3)
-      ustmin   = 0._wp      ,  &  ! minimum limit for ustar in lookup table (m/s)
-      ustmax   = 0.04_wp    ,  &  ! maximum limit for ustar in lookup table (m/s)    
-      dezehat               ,  &  ! delta zhat in lookup table
-      deustar                     ! delta ustar in lookup table
+   !                                         !!! ** Parameters for lookup table for turbulent velocity scales ** 
+   INTEGER, PARAMETER ::   nilktb   = 892     ! number of values for zehat in KPP lookup table
+   INTEGER, PARAMETER ::   njlktb   = 482     ! number of values for ustar in KPP lookup table
+   INTEGER, PARAMETER ::   nilktbm1 = nilktb-1   !
+   INTEGER, PARAMETER ::   njlktbm1 = njlktb-1   !
+
+   REAL(wp), DIMENSION(nilktb,njlktb) ::   wmlktb   ! lookup table for the turbulent vertical velocity scale (momentum)
+   REAL(wp), DIMENSION(nilktb,njlktb) ::   wslktb   ! lookup table for the turbulent vertical velocity scale (tracers)
+
+   REAL(wp) ::   dehatmin = -4.e-7_wp    ! minimum limit for zhat in lookup table (m3/s3) 
+   REAL(wp) ::   dehatmax = 0._wp        ! maximum limit for zhat in lookup table (m3/s3)
+   REAL(wp) ::   ustmin   = 0._wp        ! minimum limit for ustar in lookup table (m/s)
+   REAL(wp) ::   ustmax   = 0.04_wp      ! maximum limit for ustar in lookup table (m/s)    
+   REAL(wp) ::   dezehat                 ! delta zhat in lookup table
+   REAL(wp) ::   deustar                 ! delta ustar in lookup table
 #endif
    REAL(wp), DIMENSION(jpk) ::   ratt   ! attenuation coef  (already defines in module traqsr, 
    !                                    ! but only if the solar radiation penetration is considered)
-   REAL(wp) ::                 & !!! * penetrative solar radiation coefficient *
-      rabs = 0.58_wp        ,  &  ! fraction associated with xsi1
-      xsi1 = 0.35_wp        ,  &  ! first depth of extinction 
-      xsi2 = 23.0_wp              ! second depth of extinction 
+   
+   !                                    !!! * penetrative solar radiation coefficient *
+   REAL(wp) ::   rabs = 0.58_wp          ! fraction associated with xsi1
+   REAL(wp) ::   xsi1 = 0.35_wp          ! first depth of extinction 
+   REAL(wp) ::   xsi2 = 23.0_wp          ! second depth of extinction 
       !                           ! (default values: water type Ib) 
 
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-      etmean                ,  &  ! coefficient used for horizontal smoothing
-      eumean                ,  &  ! at t-, u- and v-points
-      evmean  
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   etmean, eumean, evmean   ! coeff. used for hor. smoothing at t-, u- & v-points
+        
  
 #if defined key_c1d
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &
-      rig                   ,  &  ! gradient Richardson number
-      rib                   ,  &  ! bulk Richardson number
-      buof                  ,  &  ! buoyancy forcing
-      mols                        ! moning-Obukhov length scale 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ekdp   ! Ekman depth
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rig    !: gradient Richardson number
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   rib    !: bulk Richardson number
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   buof   !: buoyancy forcing
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   mols   !: moning-Obukhov length scale 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)     ::   ekdp   !: Ekman depth
 #endif
 
@@ -140,12 +146,12 @@
 #  include  "zdfddm_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL   (2009)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE zdf_kpp ( kt )
+   SUBROUTINE zdf_kpp( kt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_kpp  ***
@@ -183,10 +189,10 @@
       !!----------------------------------------------------------------------
 #if defined  key_zdfddm
-      USE oce     , zviscos => ua,      &  ! temp. array for viscosities use ua as workspace
-         &          zdiffut => ta,      &  ! temp. array for diffusivities use sa as workspace
-         &          zdiffus => sa          ! temp. array for diffusivities use sa as workspace
+      USE oce     , zviscos => ua   ! temp. array for viscosities use ua as workspace
+      USE oce     , zdiffut => ta   ! temp. array for diffusivities use sa as workspace
+      USE oce     , zdiffus => sa   ! temp. array for diffusivities use sa as workspace
 #else
-      USE oce     , zviscos => ua,      &  ! temp. array for viscosities use ua as workspace
-         &          zdiffut => ta          ! temp. array for diffusivities use sa as workspace
+      USE oce     , zviscos => ua   ! temp. array for viscosities use ua as workspace
+      USE oce     , zdiffut => ta   ! temp. array for diffusivities use sa as workspace
 #endif
       !!
@@ -196,107 +202,43 @@
       INTEGER ::   ikbot, jkmax, jkm1, jkp2   !
 
-      REAL(wp), DIMENSION(jpi,jpj) ::   & !!! Surface buoyancy forcing, friction velocity
-         zBo, zBosol, zustar              !
-                      !
-      REAL(wp) ::                       &  !
-         ztx, zty, zflageos,            &  !
-         zstabl, zbuofdep,zucube,       &  !
-         zrhos, zalbet, zbeta,          &  !
-         zthermal, zhalin, zatt1           !
-     
-      REAL(wp) ::                       & !!! Bulk richardson number
-         zref, zt, zs, zh,              &  !
-         zu, zv, zrh,                   &  !
-         zrib, zrinum,                  &  !
-         zdVsq, zVtsq                      !
-      
-      REAL(wp) ::                       & !!! Velocity scales
-         zehat, zeta, zhrib, zsig,      &  !
-         zscale, zwst, zws, zwm
-
+      REAL(wp), DIMENSION(jpi,jpj) ::   zBo, zBosol, zustar         ! Surface buoyancy forcing, friction velocity
+      REAL(wp) ::   ztx, zty, zflageos, zstabl, zbuofdep,zucube     !
+      REAL(wp) ::   zrhos, zalbet, zbeta, zthermal, zhalin, zatt1   !
+      REAL(wp) ::   zref, zt, zs, zh, zu, zv, zrh                   ! Bulk richardson number
+      REAL(wp) ::   zrib, zrinum, zdVsq, zVtsq                      !
+      REAL(wp) ::   zehat, zeta, zhrib, zsig, zscale, zwst, zws, zwm   ! Velocity scales
 #if defined key_kpplktb
-      INTEGER ::                        & !!! Lookup table or Analytical functions 
-         il, jl                            !
-      REAL(wp) ::                       &  !
-         ud, zfrac, ufrac,              &  !
-         zwam, zwbm, zwas, zwbs            !
+      INTEGER ::    il, jl                                          ! Lookup table or Analytical functions 
+      REAL(wp) ::   ud, zfrac, ufrac, zwam, zwbm, zwas, zwbs        !
 #else
-     REAL(wp) ::                        &  !
-        zwsun, zwmun,                   & 
-        zcons, zconm, zwcons, zwconm      !
-#endif
- 
-     REAL(wp) ::                       & !!! In situ density
-         zsr, zbw, ze,                  &  !
-         zb, zd, zc, zaw, za,           &  !
-         zb1, za1, zkw, zk0,            &  !
-         zcomp , zrhd, zrhdr,zbvzed       !
-
+      REAL(wp) ::   zwsun, zwmun, zcons, zconm, zwcons, zwconm      !
+#endif
+      REAL(wp) ::   zsr, zbw, ze, zb, zd, zc, zaw, za, zb1, za1, zkw, zk0, zcomp , zrhd,zrhdr,zbvzed   ! In situ density
 #if ! defined key_kppcustom     
-     !! * local declarations
-      INTEGER ::                        &
-         jm                                ! dummy loop indices
-      REAL(wp) ::                       & !!! Compression terms
-         zr1, zr2, zr3, zr4,            &  !
-         zrhop                             !
-#endif
- 
-      REAL(wp) ::                       &  !
-         zflag, ztemp, zrn2,            &  !
-         zdep21, zdep32, zdep43
-
-      REAL(wp) ::                       & !!! Interior richardson mixing
-         zdku2, zdkv2, ze3sqr,          &  !
-         zsh2, zri, zfri                   !
-
-      REAL(wp), DIMENSION(jpi,0:2) ::  &  !!! Moning-Obukov limitation
-         zmoek
-      REAL(wp), DIMENSION(jpi)     ::  &
-         zmoa, zekman                
-      REAL(wp)                     ::  &
-         zmob, zek
-
-      REAL(wp), DIMENSION(jpi,4) ::     &  !!! The pipe 
-         zdepw, zdift, zvisc
-      REAL(wp), DIMENSION(jpi,3) ::     & 
-         zdept
-      REAL(wp), DIMENSION(jpi,2) ::     &  
-         zriblk
-      REAL(wp), DIMENSION(jpi,jpk) ::   &  !
-         zmask                          
-      REAL(wp), DIMENSION(jpi) ::       &  ! 
-         zhmax, zria, zhbl 
-      REAL(wp) ::                       &  !
-         zflagri, zflagek,              &  !
-         zflagmo, zflagh, zflagkb          !
-      REAL(wp), DIMENSION(jpi)     ::   & !!! Shape function (G)
-         za2m, za3m, zkmpm,             &
-         za2t, za3t, zkmpt
-      REAL(wp) ::                       &  !
-         zdelta, zdelta2,               &  !
-         zdzup, zdzdn, zdzh,            &  !
-         zvath, zgat1, zdat1,           &  !
-         zkm1m, zkm1t
-      REAL(wp), DIMENSION(jpi,jpk) ::   & !!! Boundary layer diffusivities/viscosities
-         zblcm, zblct                          
+      INTEGER  ::   jm                          ! dummy loop indices
+      REAL(wp) ::   zr1, zr2, zr3, zr4, zrhop   ! Compression terms
+#endif
+      REAL(wp) ::   zflag, ztemp, zrn2, zdep21, zdep32, zdep43
+      REAL(wp) ::   zdku2, zdkv2, ze3sqr, zsh2, zri, zfri          ! Interior richardson mixing
+      REAL(wp), DIMENSION(jpi,0:2) ::   zmoek                      ! Moning-Obukov limitation
+      REAL(wp), DIMENSION(jpi)     ::   zmoa, zekman                
+      REAL(wp)                     ::   zmob, zek
+      REAL(wp), DIMENSION(jpi,4)   ::   zdepw, zdift, zvisc   ! The pipe 
+      REAL(wp), DIMENSION(jpi,3)   ::   zdept
+      REAL(wp), DIMENSION(jpi,2)   ::   zriblk
+      REAL(wp), DIMENSION(jpi,jpk) ::   zmask                          
+      REAL(wp), DIMENSION(jpi)     ::   zhmax, zria, zhbl 
+      REAL(wp) ::   zflagri, zflagek, zflagmo, zflagh, zflagkb   !
+      REAL(wp), DIMENSION(jpi)     ::   za2m, za3m, zkmpm, za2t, za3t, zkmpt   ! Shape function (G)
+      REAL(wp) ::   zdelta, zdelta2, zdzup, zdzdn, zdzh, zvath, zgat1, zdat1, zkm1m, zkm1t
+      REAL(wp), DIMENSION(jpi,jpk) ::   zblcm, zblct   ! Boundary layer diffusivities/viscosities
 #if defined key_zdfddm
-      REAL(wp) ::                       & !!! double diffusion mixing
-         zrrau, zds,                    &
-         zavdds, zavddt,zinr 
-      REAL(wp), DIMENSION(jpi,4) ::     &  
-        zdifs
-      REAL(wp), DIMENSION(jpi)     ::   &
-         za2s, za3s, zkmps
-      REAL(wp) ::                       & 
-         zkm1s
-      REAL(wp), DIMENSION(jpi,jpk) ::   & 
-         zblcs                     
+      REAL(wp) ::   zrrau, zds, zavdds, zavddt,zinr   ! double diffusion mixing
+      REAL(wp), DIMENSION(jpi,4) ::     zdifs
+      REAL(wp), DIMENSION(jpi)     ::   za2s, za3s, zkmps
+      REAL(wp) ::                       zkm1s
+      REAL(wp), DIMENSION(jpi,jpk) ::   zblcs                     
 #endif
       !!--------------------------------------------------------------------
-
-
-      ! Initialization (first time-step only)
-      ! --------------
-      IF( kt == nit000  )   CALL zdf_kpp_init
      
       zviscos(:,:,:) = 0.
@@ -453,9 +395,9 @@
             zBosol(ji,jj) = grav * zthermal * qsr(ji,jj)
             ! Non radiative surface buoyancy force
-            zBo   (ji,jj) = grav * zthermal * qns(ji,jj) -  grav * zhalin * emps(ji,jj)
+            zBo   (ji,jj) = grav * zthermal * qns(ji,jj) -  grav * zhalin * ( emps(ji,jj)-rnf(ji,jj) ) 
             ! Surface Temperature flux for non-local term
             wt0(ji,jj) = - ( qsr(ji,jj) + qns(ji,jj) )* ro0cpr * tmask(ji,jj,1)
             ! Surface salinity flux for non-local term
-            ws0(ji,jj) = - ( emps(ji,jj) * sn(ji,jj,1) * rcs ) * tmask(ji,jj,1)
+            ws0(ji,jj) = - ( ( emps(ji,jj)-rnf(ji,jj) ) * sn(ji,jj,1) * rcs ) * tmask(ji,jj,1) 
          ENDDO
       ENDDO
@@ -497,5 +439,5 @@
             zria(ji ) = 0.
             ! Maximum boundary layer depth
-            ikbot     = mbathy(ji,jj) - 1 ! ikbot is the last T point in the water
+            ikbot     = mbkt(ji,jj)    ! ikbot is the last T point in the water
             zhmax(ji) = fsdept(ji,jj,ikbot) - 0.001      
             ! Compute Monin obukhov length scale at the surface and Ekman depth:
@@ -1236,15 +1178,9 @@
       !!                  ***  ROUTINE tra_kpp  ***
       !!
-      !! ** Purpose :   compute and add to the tracer trend the non-local
-      !!      tracer flux
+      !! ** Purpose :   compute and add to the tracer trend the non-local tracer flux
       !!
       !! ** Method  :   ???
-      !!
-      !! history :
-      !!     9.0  ! 05-11 (G. Madec)  Original code
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce, ONLY :    ztrdt => ua,       & ! use ua as 3D workspace
-                         ztrds => va          ! use va as 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) :: kt
@@ -1252,26 +1188,24 @@
 
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 
          IF(lwp) WRITE(numout,*) 'tra_kpp : KPP non-local tracer fluxes'
          IF(lwp) WRITE(numout,*) '~~~~~~~   '
       ENDIF
 
-
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztrdt(:,:,:) = ta(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:)
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
       ! add non-local temperature and salinity flux ( in convective case only)
       DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
+         DO jj = 2, jpjm1 
             DO ji = fs_2, fs_jpim1
-               ta(ji,jj,jk) =  ta(ji,jj,jk)                           &
-                  &         - ( ghats(ji,jj,jk  ) * avt(ji,jj,jk  )   &
-                  &           - ghats(ji,jj,jk+1) * avt(ji,jj,jk+1) ) * wt0(ji,jj) / fse3t(ji,jj,jk)
-               sa(ji,jj,jk) = sa(ji,jj,jk)                              &
-                  &         - ( ghats(ji,jj,jk  ) * fsavs(ji,jj,jk  )   &
-                  &           - ghats(ji,jj,jk+1) * fsavs(ji,jj,jk+1) ) * ws0(ji,jj) / fse3t(ji,jj,jk)
+               tsa(ji,jj,jk,jp_tem) =  tsa(ji,jj,jk,jp_tem)                      &
+                  &                 - (  ghats(ji,jj,jk  ) * avt  (ji,jj,jk  )   & 
+                  &                    - ghats(ji,jj,jk+1) * avt  (ji,jj,jk+1) ) * wt0(ji,jj) / fse3t(ji,jj,jk)
+               tsa(ji,jj,jk,jp_sal) =  tsa(ji,jj,jk,jp_sal)                      &
+                  &                 - (  ghats(ji,jj,jk  ) * fsavs(ji,jj,jk  )   & 
+                  &                    - ghats(ji,jj,jk+1) * fsavs(ji,jj,jk+1) ) * ws0(ji,jj) / fse3t(ji,jj,jk)
             END DO
          END DO
@@ -1280,17 +1214,84 @@
       ! save the non-local tracer flux trends for diagnostic
       IF( l_trdtra )   THEN
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
 !!bug gm jpttdzdf ==> jpttkpp
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_zdf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_zdf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
       ENDIF
 
-      IF(ln_ctl) THEN  
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' kpp  - Ta: ', mask1=tmask,   &
-         &             tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl) THEN
+         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' kpp  - Ta: ', mask1=tmask,   &
+         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       ENDIF
 
    END SUBROUTINE tra_kpp
 
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   SUBROUTINE trc_kpp( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_kpp  ***
+      !!
+      !! ** Purpose :   compute and add to the tracer trend the non-local
+      !!                tracer flux
+      !!
+      !! ** Method  :   ???
+      !!
+      !! history :
+      !!            9.0  ! 2005-11 (G. Madec)  Original code
+      !!       NEMO 3.3  ! 2010-06 (C. Ethe )  Adapted to passive tracers
+      !!----------------------------------------------------------------------
+      USE trc
+      USE prtctl_trc          ! Print control
+      !! * Arguments
+      INTEGER ,                         INTENT( in    )  :: kt     ! ocean time-step index
+      !! * Local declarations
+      INTEGER  ::   ji, jj, jk, jn      ! Dummy loop indices
+      REAL(wp) ::   ztra, zflx
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*) 
+         IF(lwp) WRITE(numout,*) 'trc_kpp : KPP non-local tracer fluxes'
+         IF(lwp) WRITE(numout,*) '~~~~~~~   '
+      ENDIF
+
+      IF( l_trdtrc )  ALLOCATE( ztrtrd(jpi,jpj,jpk) )
+      !
+      DO jn = 1, jptra
+         !
+         IF( l_trdtrc )  ztrtrd(:,:,:)  = tra(:,:,:,jn)
+         ! add non-local on passive tracer flux ( in convective case only)
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1 
+               DO ji = fs_2, fs_jpim1
+                  ! Surface tracer flux for non-local term 
+                  zflx = - ( emps(ji,jj) * tra(ji,jj,1,jn) * rcs ) * tmask(ji,jj,1)
+                  ! compute the trend
+                  ztra = - ( ghats(ji,jj,jk  ) * fsavs(ji,jj,jk  )   &
+                  &        - ghats(ji,jj,jk+1) * fsavs(ji,jj,jk+1) ) * zflx / fse3t(ji,jj,jk)
+                  ! add the trend to the general trend
+                  tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn)  + ztra
+               END DO
+            END DO
+         END DO
+         ! save the non-local tracer flux trends for diagnostic
+         IF( l_trdtrc )  ztrtrd(:,:,:)  = tra(:,:,:,jn) - ztrtrd(:,:,:)
+         CALL trd_tra( kt, 'TRC', jn, jptra_trd_zdf, ztrtrd(:,:,:,jn) )
+         !
+      END DO
+      IF( l_trdtrc )  DEALLOCATE( ztrtrd )
+      IF( ln_ctl )   THEN
+         WRITE(charout, FMT="(' kpp')")  ;  CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=clname, clinfo2='trd' )
+      ENDIF
+      !
+   END SUBROUTINE trc_kpp
+#endif
 
    SUBROUTINE zdf_kpp_init
@@ -1305,33 +1306,16 @@
       !!
       !! ** input   :   Namlist namkpp
-      !!
-      !!
-      !! history :
-      !!     8.1  ! 00-02 (J. Chanut) KPP Mixing
-      !!     9.0  ! 05-01 (C. Ethe) F90 : free form
       !!----------------------------------------------------------------------
-      !! * local declarations
-
-      INTEGER    ::   &
-         ji, jj, jk             ! dummy loop indices
-      
+      INTEGER  ::   ji, jj, jk     ! dummy loop indices
 #if ! defined key_kppcustom
-      INTEGER    ::   &
-         jm                       ! dummy loop indices     
-      REAL(wp)   ::              & !!! tempory scalars
-         zref, zdist
-#endif
-
+      INTEGER  ::   jm             ! dummy loop indices     
+      REAL(wp) ::   zref, zdist    ! tempory scalars
+#endif
 #if defined key_kpplktb
-      REAL(wp)   ::              & !!! tempory scalars
-         zustar,    &
-         zucube, zustvk,         & 
-         zeta, zehat
-#endif
-      REAL(wp)   ::             & !!! tempory scalars
-         zhbf
-      LOGICAL ::                &
-         ll_kppcustom,          &  ! 1st ocean level taken as surface layer
-         ll_kpplktb                ! Lookup table for turbul. velocity scales 
+      REAL(wp) ::   zustar, zucube, zustvk, zeta, zehat   ! tempory scalars
+#endif
+      REAL(wp) ::   zhbf           ! tempory scalars
+      LOGICAL  ::   ll_kppcustom   ! 1st ocean level taken as surface layer
+      LOGICAL  ::   ll_kpplktb     ! Lookup table for turbul. velocity scales 
       !!
       NAMELIST/namzdf_kpp/ ln_kpprimix, rn_difmiw, rn_difsiw, rn_riinfty, rn_difri, rn_bvsqcon, rn_difcon, nn_ave
@@ -1540,10 +1524,18 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_zdfkpp = .FALSE.   !: KPP flag
 CONTAINS
-   SUBROUTINE zdf_kpp( kt )          ! Empty routine
+   SUBROUTINE zdf_kpp_init           ! Dummy routine
+      WRITE(*,*) 'zdf_kpp_init: You should not have seen this print! error?'
+   END SUBROUTINE zdf_kpp_init
+   SUBROUTINE zdf_kpp( kt )          ! Dummy routine
       WRITE(*,*) 'zdf_kpp: You should not have seen this print! error?', kt
    END SUBROUTINE zdf_kpp
-   SUBROUTINE tra_kpp( kt )          ! Empty routine
+   SUBROUTINE tra_kpp( kt )          ! Dummy routine
       WRITE(*,*) 'tra_kpp: You should not have seen this print! error?', kt
    END SUBROUTINE tra_kpp
+#if defined key_top
+   SUBROUTINE trc_kpp( kt )          ! Dummy routine
+      WRITE(*,*) 'trc_kpp: You should not have seen this print! error?', kt
+   END SUBROUTINE trc_kpp
+#endif
 #endif
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 2528)
@@ -29,7 +29,7 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -69,6 +69,6 @@
 
       ! w-level of the mixing and mixed layers
-      nmln(:,:) = mbathy(:,:)          ! Initialization to the number of w ocean point mbathy
-      imld(:,:) = mbathy(:,:)
+      nmln(:,:) = mbkt(:,:) + 1        ! Initialization to the number of w ocean point
+      imld(:,:) = mbkt(:,:) + 1
       DO jk = jpkm1, nlb10, -1         ! from the bottom to nlb10
          DO jj = 1, jpj
